
// MFC_PIDINFO_TrainingDlg.cpp :  
//

#include "stdafx.h"

#include "MFC_PIDINFO_Training.h"
#include "MFC_PIDINFO_TrainingDlg.h"

#include "DefineData.h"

#include <iphlpapi.h>
#include <vector>

char* g_mibTCPState[] =  
{
	"???",
	"MIB_TCP_STATE_CLOSED",
	"MIB_TCP_STATE_LISTEN",
	"MIB_TCP_STATE_SYN_SENT",
	"MIB_TCP_STATE_SYN_RCVD",
	"MIB_TCP_STATE_ESTAB",
	"MIB_TCP_STATE_FIN_WAIT1",
	"MIB_TCP_STATE_FIN_WAIT2",
	"MIB_TCP_STATE_CLOSE_WAIT",
	"MIB_TCP_STATE_CLOSING",
	"MIB_TCP_STATE_LAST_ACK",
	"MIB_TCP_STATE_TIME_WAIT",
	"MIB_TCP_STATE_DELETE_TCB" 
};

DWORD (WINAPI *pGetExtendedTcpTable)(
									 PVOID pTcpTable, PDWORD pdwSize, BOOL bOrder, ULONG ulAf, TCP_TABLE_CLASS TableClass, ULONG Reserved
									 );

std::vector <NETINFO> m_vNetinfo;

LPDIRECT3D9       g_pD3D       = NULL;
LPDIRECT3DDEVICE9 g_pd3dDevice = NULL;

//#pragma comment(lib, "iphlpapi.lib")
//#pragma comment( lib, "Ws2_32.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


//  α׷  Ǵ CAboutDlg ȭ Դϴ.

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// ȭ  Դϴ.
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.

// Դϴ.
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CMFC_PIDINFO_TrainingDlg ȭ 




CMFC_PIDINFO_TrainingDlg::CMFC_PIDINFO_TrainingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMFC_PIDINFO_TrainingDlg::IDD, pParent)
	, m_szFilePath(_T(""))
	, m_dwPid(0)
	, m_strIP(_T(""))
	, m_bLoadState(FALSE)
	, m_nPORT(0)
	, m_bScreenAutoCap(FALSE)
	, m_D3state(FALSE)
	, m_bSnapKeyState(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFC_PIDINFO_TrainingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_INFO, m_lbListBox);
	DDX_Text(pDX, IDC_EDIT_FILEPATH, m_szFilePath);
	DDX_Control(pDX, IDC_LIST_VECTOR, m_lbVector);
	DDX_Check(pDX, IDC_CHECK_AUTOPIC, m_bScreenAutoCap);
}

BEGIN_MESSAGE_MAP(CMFC_PIDINFO_TrainingDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CMFC_PIDINFO_TrainingDlg::OnBnClickedOk)
	ON_WM_DROPFILES()
	ON_BN_CLICKED(IDC_BUTTON_RELOAD, &CMFC_PIDINFO_TrainingDlg::OnBnClickedButtonReload)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_VECTOR, &CMFC_PIDINFO_TrainingDlg::OnBnClickedButtonVector)
	ON_BN_CLICKED(IDC_BUTTON_PRTSC, &CMFC_PIDINFO_TrainingDlg::OnBnClickedButtonPrtsc)
	ON_BN_CLICKED(IDC_CHECK_AUTOPIC, &CMFC_PIDINFO_TrainingDlg::OnBnClickedCheckAutopic)
	ON_WM_DESTROY()
	ON_WM_CLIPBOARDUPDATE()
END_MESSAGE_MAP()


// CMFC_PIDINFO_TrainingDlg ޽ ó

BOOL CMFC_PIDINFO_TrainingDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ý ޴ "..." ޴ ׸ ߰մϴ.

	// IDM_ABOUTBOX ý   ־ մϴ.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	// TODO: ⿡ ߰ ʱȭ ۾ ߰մϴ.

	hDll = LoadLibraryA( DEF_DLL_NAME );

	if( hDll == NULL )
	{	
		m_lbListBox.AddString(_T("FAIL! To Load DLL"));
		return 0;	
	}
	//MessageBox( "SUCESS! To Load DLL" );

	HookStart	= ( PFN_HOOKSTART )GetProcAddress(hDll, DEF_HOOKSTART);
	HookStop	= ( PFN_HOOKSTOP )GetProcAddress(hDll, DEF_HOOKSTOP);

	HookStart();

	m_lbListBox.AddString(_T("1.  "));
	m_lbListBox.AddString(_T("2. Ȯ"));
	m_lbListBox.AddString(_T("3. Ȯ"));
	m_lbListBox.AddString(_T("4. ũ Ű F12"));
	m_lbListBox.AddString(_T("5. Ŭ ĸĴ '.bmp'   "));
	m_lbListBox.AddString(_T("== ڵ ũ ֱ 1 =="));

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

void CMFC_PIDINFO_TrainingDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// ȭ ڿ ּȭ ߸ ߰   ׸
//  Ʒ ڵ尡 ʿմϴ. /  ϴ MFC  α׷ 쿡
//  ӿũ  ۾ ڵ մϴ.

void CMFC_PIDINFO_TrainingDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ׸⸦  ̽ ؽƮ

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Ŭ̾Ʈ 簢   ϴ.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		//  ׸ϴ.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// ڰ ּȭ â  ȿ Ŀ ǥõǵ ýۿ
//   Լ ȣմϴ.
HCURSOR CMFC_PIDINFO_TrainingDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CMFC_PIDINFO_TrainingDlg::OnBnClickedOk()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if(m_szFilePath.IsEmpty())
	{
		m_lbListBox.AddString(_T(" ־ּ"));
		return;
	}

	SHELLEXECUTEINFO ShExecInfo;
	memset(&ShExecInfo, NULL, sizeof(SHELLEXECUTEINFO));

	ShExecInfo.cbSize = sizeof(SHELLEXECUTEINFO);
	ShExecInfo.fMask = SEE_MASK_NOCLOSEPROCESS;
	ShExecInfo.lpFile = m_szFilePath;
	ShExecInfo.nShow = SW_SHOW;

	BOOL ret = ShellExecuteEx(&ShExecInfo);

	if(!ret)
	{
		m_lbListBox.AddString(_T(""));
		return;
	}

	m_dwPid = GetProcessId(ShExecInfo.hProcess);
	CloseHandle(ShExecInfo.hProcess);

	CString add_msg;
	add_msg.Format(_T("PID : %ld"), m_dwPid);
	m_lbListBox.AddString(add_msg);	
}

void CMFC_PIDINFO_TrainingDlg::OnDropFiles(HDROP hDropInfo)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.

	char FileFath[MAX_PATH];

	DragQueryFileA(hDropInfo, 0, FileFath, MAX_PATH);
	
	m_szFilePath = FileFath;
	m_lbListBox.AddString(m_szFilePath);

	UpdateData(FALSE);

	CDialog::OnDropFiles(hDropInfo);
}

BOOL CMFC_PIDINFO_TrainingDlg::initFunctions(void)
{
	pGetExtendedTcpTable =
		(DWORD (WINAPI *)(PVOID,PDWORD,BOOL,ULONG,TCP_TABLE_CLASS,ULONG))
		GetProcAddress(LoadLibraryA("iphlpapi.dll"), "GetExtendedTcpTable");
	if(pGetExtendedTcpTable == NULL) return FALSE;
	return TRUE;
}

void CMFC_PIDINFO_TrainingDlg::OnBnClickedButtonReload()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	m_bLoadState = !m_bLoadState;

	if(m_bLoadState)
	{
		m_lbListBox.AddString(_T("Ž"));
		SetTimer(IP_PORT_RELOAD, 1000, 0);
	}
	else
	{
		m_lbListBox.AddString(_T(""));
		KillTimer(IP_PORT_RELOAD);
	}

}

CString CMFC_PIDINFO_TrainingDlg::GetPid2Info(DWORD SrcPid)
{
	CString err_msg;

	if(!initFunctions()){

		err_msg = _T("Needed to have XP SP2, Vista SP1 or Server 2003 SP1 and above");
		return err_msg;
	}

	PVOID pTCPTable = NULL;
	DWORD size = 0;
	DWORD result = 0;

	result = pGetExtendedTcpTable(NULL, &size, true, AF_INET, TCP_TABLE_OWNER_MODULE_ALL, 0);
	while(result == ERROR_INSUFFICIENT_BUFFER){
		if(pTCPTable != NULL){
			free(pTCPTable);
		}
		pTCPTable = malloc(size);
		result = pGetExtendedTcpTable(pTCPTable, &size, true, AF_INET, TCP_TABLE_OWNER_MODULE_ALL, 0);
		if(result != NO_ERROR){
			err_msg.Format(_T("Failed to get TCP Table %s"), GetLastError());
			free(pTCPTable);
			m_lbListBox.AddString(err_msg);
			return err_msg;
		}
	}

	if(result != NO_ERROR){
		err_msg.Format(_T("Failed to get size estimation %s"), GetLastError());
		m_lbListBox.AddString(err_msg);
		return err_msg;
	}

	for(DWORD i = 0; i < ((PMIB_TCPTABLE_OWNER_MODULE)pTCPTable)->dwNumEntries; i++)
	{
		MIB_TCPROW_OWNER_MODULE module = ((PMIB_TCPTABLE_OWNER_MODULE)pTCPTable)->table[i];
		if(SrcPid == module.dwOwningPid)
		{
			if(module.dwState != MIB_TCP_STATE_LISTEN)
			{				
				CString t1;
				int t2;
				BOOL trance;
				trance = TRUE;
				t1.Format(_T("%d.%d.%d.%d"),
					(htonl(module.dwRemoteAddr) >> 24) & 0xFF,
					(htonl(module.dwRemoteAddr) >> 16) & 0xFF,
					(htonl(module.dwRemoteAddr) >>  8) & 0xFF,
					(htonl(module.dwRemoteAddr)) & 0xFF);
				t2 = (unsigned int)htons((short)module.dwRemotePort);

				for(int i=0; i < (int)m_vNetinfo.size(); i++)
				{
					if(m_vNetinfo[i].IP == t1 && m_vNetinfo[i].PORT == t2 )
					{
						trance = FALSE;
					}
				}

				if(trance || m_vNetinfo.size() == 0)
				{
					NETINFO tinfo;
					tinfo.IP = t1;
					tinfo.PORT = t2;
					m_vNetinfo.push_back(tinfo);
				}				

				CString add_msg;
				m_strIP = t1;
				m_nPORT = t2;
				add_msg.Format(_T("IP : %s / PORT : %d"), m_strIP.GetBuffer(), m_nPORT);

				m_lbListBox.AddString(add_msg);
			}
		}
	}

	if(pTCPTable != NULL) 
	{
		free(pTCPTable);
	}

	err_msg.Empty();

	return err_msg;
}

void CMFC_PIDINFO_TrainingDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.


	switch(nIDEvent)
	{
	case IP_PORT_RELOAD:
		{
			CString t;

			t = GetPid2Info(m_dwPid);


			if(!t.IsEmpty())
			{
				m_lbListBox.AddString(t);
			}	

			break;
		}
	case SCREEN_RELOAD:
		{
			HWND hwnd = GetWindowHandle(m_dwPid);

			HWND2IMG(hwnd);
			break;
		}
	}
	

	CDialog::OnTimer(nIDEvent);
}

void CMFC_PIDINFO_TrainingDlg::OnBnClickedButtonVector()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	m_lbVector.ResetContent();

	CString ttt;

	for(int i=0; i < (int)m_vNetinfo.size(); i++)
	{
		ttt.Format(_T("IP : %s / PORT : %d"), m_vNetinfo[i].IP.GetBuffer(), m_vNetinfo[i].PORT);
		m_lbVector.AddString(ttt);
	}
}

HWND CMFC_PIDINFO_TrainingDlg::GetWindowHandle(DWORD processid)
{
	HWND tmpHwnd = ::FindWindow(NULL, NULL);
	DWORD idProc = 0;

	while(tmpHwnd!= NULL)
	{
		if( ::GetParent(tmpHwnd) == NULL )  // ֻ ڵ üũ, ư  ڵ   Ƿ ϱ 
		{
			GetWindowThreadProcessId( tmpHwnd, &idProc );
			if( processid == idProc)
			{
				return tmpHwnd;
			}
		}
		tmpHwnd = ::GetWindow(tmpHwnd, GW_HWNDNEXT); //  ڵ ã
	}

	return tmpHwnd;
}

void CMFC_PIDINFO_TrainingDlg::OnBnClickedButtonPrtsc()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	HWND m_hwnd_f = GetWindowHandle(m_dwPid);

	CString add_msg;
	add_msg.Format(_T("HWND : %x"), m_hwnd_f);
	m_lbListBox.AddString(add_msg);

	if(m_hwnd_f == NULL)
	{
		m_lbListBox.AddString(_T("ڵ ã Ͽϴ."));
		m_lbListBox.AddString(_T("(â  Ŀ ٽ õ غ)"));
		return;
	}	

	//ĸó
	INPUT inp[4];
	ZeroMemory(inp, sizeof(inp));

	//press the VK_MENU key
	inp[0].type = INPUT_KEYBOARD;
	inp[0].ki.wVk = VK_MENU;

	//press the VK_SNAPSHOT key
	inp[1].type = INPUT_KEYBOARD;
	inp[1].ki.wVk = VK_SNAPSHOT;

	//release the VK_SNAPSHOT key
	inp[2] = inp[1];
	inp[2].ki.dwFlags |= KEYEVENTF_KEYUP;

	//release the VK_MENU key
	inp[3] = inp[0];
	inp[3].ki.dwFlags |= KEYEVENTF_KEYUP;

	//simulate keyboard events and check success of function
	SendInput(4, inp, sizeof(INPUT));

	AddClipboardFormatListener(GetSafeHwnd());

	m_bSnapKeyState = TRUE;
	//ĸó 

	static D3DDISPLAYMODE d3ddm;

	if(!m_D3state)
	{		
		g_pD3D = Direct3DCreate9( D3D_SDK_VERSION );

		g_pD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT, &d3ddm);

		D3DPRESENT_PARAMETERS d3dpp;
		ZeroMemory( &d3dpp, sizeof(d3dpp) );

		d3dpp.Windowed               = TRUE;
		d3dpp.SwapEffect             = D3DSWAPEFFECT_DISCARD;
		d3dpp.BackBufferFormat       = d3ddm.Format;
		d3dpp.EnableAutoDepthStencil = TRUE;
		d3dpp.AutoDepthStencilFormat = D3DFMT_D24S8;
		d3dpp.Flags                  = D3DPRESENTFLAG_DISCARD_DEPTHSTENCIL;
		d3dpp.PresentationInterval   = D3DPRESENT_INTERVAL_IMMEDIATE;

		g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, m_hwnd_f,
			D3DCREATE_SOFTWARE_VERTEXPROCESSING,
			//D3DCREATE_HARDWARE_VERTEXPROCESSING | D3DCREATE_PUREDEVICE,
			&d3dpp, &g_pd3dDevice );

		m_D3state = TRUE;
	}

	CString sizz;
	sizz.Format(_T("ػ == W : %d, H : %d"), GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));
	m_lbListBox.AddString(sizz);	

	HWND2IMG(m_hwnd_f);

	//CaptureScreen(g_pd3dDevice, d3ddm, "Լȿ ۼ");
	//CaptureScreen2(g_pd3dDevice, d3ddm, "Լȿ ۼ");
	//CaptureScreen(g_pd3dDevice, d3ddm, m_hwnd_f, "Լȿ ۼ");
	//CaptureScreen2(g_pd3dDevice, d3ddm, m_hwnd_f, "Լȿ ۼ");
}

BOOL CMFC_PIDINFO_TrainingDlg::HWND2IMG(HWND DsthWnd)
{
	CDC memDC;
	CDC *pDC = CDC::FromHandle(::GetDC(DsthWnd));

	//CreateOffscreenPlainSurface();
	//IDirect3DSurface9 

	CBitmap MyBitmap, *pOld;
	memDC.CreateCompatibleDC(pDC);

	CRect rect;
	::GetClientRect(DsthWnd, &rect);

	CString ttt;
	ttt.Format(_T("Width : %d, Height : %d"), rect.Width(), rect.Height());
	m_lbListBox.AddString(ttt);

	MyBitmap.CreateCompatibleBitmap(pDC, rect.Width(),rect.Height()); // ȭ鿡 256*256 ɴϴ.

	pOld = memDC.SelectObject(&MyBitmap);


	memDC.BitBlt(0, 0, rect.Width(), rect.Height(), pDC, 0, 0, SRCCOPY);

	memDC.SelectObject(pOld);

	ReleaseDC(&memDC);

	CImage image; // Cimage Ἥ  bmpȭ ŵϴ.
	image.Attach(MyBitmap);

	CString filename;

	CTime filenameset;
	filenameset = CTime::GetCurrentTime();

	filename = filenameset.Format("%y%m%d%H%M%S");
	filename += _T(".png");

	image.Save(filename);

	return 0;
}

LRESULT CMFC_PIDINFO_TrainingDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.

	switch( message )
	{
	case WM_USER+1:
		{			
			OnBnClickedButtonPrtsc();
			break;
		}
	}

	return CDialog::WindowProc(message, wParam, lParam);
}

void CMFC_PIDINFO_TrainingDlg::OnBnClickedCheckAutopic()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	UpdateData(TRUE);

	if(m_bScreenAutoCap)
	{
		SetTimer(SCREEN_RELOAD, 1000, 0);
		m_lbListBox.AddString(_T("ڵ "));
	}
	else
	{
		KillTimer(SCREEN_RELOAD);
		m_lbListBox.AddString(_T("ڵ "));
	}
}

BOOL CMFC_PIDINFO_TrainingDlg::Create(LPCTSTR lpszTemplateName, CWnd* pParentWnd)
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.	

	return CDialog::Create(lpszTemplateName, pParentWnd);
}

void CMFC_PIDINFO_TrainingDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
	
	if(m_D3state)
	{
		g_pD3D->Release();
		g_pd3dDevice->Release();
	}
}

void CMFC_PIDINFO_TrainingDlg::OnClipboardUpdate()
{
	//   Ϸ Windows Vista ̻ ־ մϴ.
	// _WIN32_WINNT ȣ 0x0600 ũų ƾ մϴ.
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.

	if(m_bSnapKeyState)
	{
		CString filename;
		filename = _T(".bmp");

		CString err_msg;
		if(!ClipBoard2IMG(filename, NULL, &err_msg))
		{		
			m_lbListBox.AddString(err_msg);
		}
	}	

	m_bSnapKeyState = FALSE;
	RemoveClipboardFormatListener(GetSafeHwnd());

	CDialog::OnClipboardUpdate();
}

